Hooks:PostHook(ContractBoxGui,"init","sll_contractboxgui_init",function(self,ws,fullscreen_ws)
	if not ShareLobbyLink.settings.invite_button_visible then
		return
	end
	
	local text_color_default = Color(ShareLobbyLink.settings.text_color_default)
	local text_color_mouseover = Color(ShareLobbyLink.settings.text_color_mouseover)
	local bg_color = Color(ShareLobbyLink.settings.bg_color)
	
	local panel = self._panel
	
	local button_w = 200
	local button_h = 48
	local icon_size = 32
	local margin_small = 4
	local margin_medium = 16
	if alive(panel) then 
		self._mouseover_sll_panel = nil --flag to store mouseover state
		
		local copy_invite_button_panel = panel:panel({
			name = "copy_invite_button_panel",
			layer = 1,
			x = 0,
			y = 64,
			w = button_w,
			h = button_h
		})
		self._sll_copy_invite_button_panel = copy_invite_button_panel
		
		local copy_icon_texture,copy_icon_texture_rect = tweak_data.hud_icons:get_icon_data("sidebar_broker")
		local copy_invite_button_icon = copy_invite_button_panel:bitmap({
			name = "copy_invite_button_icon",
			color = text_color_default,
			x = margin_small,
			y = (copy_invite_button_panel:h() - icon_size) / 2,
			w = icon_size,
			h = icon_size,
			texture = copy_icon_texture,
			texture_rect = copy_icon_texture_rect,
			layer = 2,
		})
		local copy_invite_button_text = copy_invite_button_panel:text({
			name = "copy_invite_button_text",
			text = managers.localization:text("menu_sll_copy_invite_button_text"),
			font_size = tweak_data.menu.pd2_medium_font_size,
			font = tweak_data.menu.pd2_medium_font,
			color = text_color_default,
			x = copy_invite_button_icon:right() + margin_small,
			align = "left",
			vertical = "center",
			layer = 4
		})
		
		local _x,_y,_w,_h = copy_invite_button_text:text_rect()
		copy_invite_button_text:set_w(_w + icon_size + margin_small + margin_small + margin_medium)
		
		local copy_invite_button_gradient = copy_invite_button_panel:gradient({
			name = "copy_invite_button_gradient",
			gradient_points = {
				0,Color.black,
				1,Color.white
			},
			orientation = "vertical",
			blend_mode = "sub",
			alpha = 0.25,
			layer = 3,
			visible = true
		})
		local copy_invite_button_bar = copy_invite_button_panel:rect({
			name = "copy_invite_button_bar",
			color = Color.white,
			w = 8,
			x = 0,
			alpha = 1,
			layer = 3,
			visible = false
		})
		
		local copy_invite_button_bg = copy_invite_button_panel:rect({
			name = "copy_invite_button_bg",
			color = bg_color,
			alpha = 1,
			layer = 1
		})
		
	end
end)

local ids_leftclick = Idstring("0")
Hooks:PostHook(ContractBoxGui,"mouse_pressed","sll_contractboxgui_mouse_pressed",function(self,button,x,y)
	if not self:can_take_input() then 
		return
	end
	local sll_panel = self._sll_copy_invite_button_panel
	if alive(sll_panel) and sll_panel:visible() then 
		if button == ids_leftclick then 
			local mouseover_panel = sll_panel:child("copy_invite_button_bar")
			if alive(mouseover_panel) then
				if sll_panel:inside(x,y) then 
					mouseover_panel:stop()
					mouseover_panel:animate(ShareLobbyLink.animate_clicked)
					
					ShareLobbyLink:copy_lobby_link_to_clipboard()
				end
			end
		end
	end
end)

Hooks:OverrideFunction(ContractBoxGui,"mouse_moved",function(self,x,y)
	if not self:can_take_input() then
		return
	end

	local used = false
	local pointer = "arrow"
	
	local sll_panel = self._sll_copy_invite_button_panel
	if alive(sll_panel) and sll_panel:visible() then 
		local mouseover_panel = sll_panel:child("copy_invite_button_bar")
		if alive(mouseover_panel) then
			local text_color_default = Color(ShareLobbyLink.settings.text_color_default)
			local text_color_mouseover = Color(ShareLobbyLink.settings.text_color_mouseover)
			
			if sll_panel:inside(x,y) then 
				self._mouseover_sll_panel = true
				mouseover_panel:set_visible(true)
				used = true
				pointer = "link"
				
				sll_panel:child("copy_invite_button_icon"):set_color(text_color_mouseover)
				sll_panel:child("copy_invite_button_text"):set_color(text_color_mouseover)
				
			elseif self._mouseover_sll_panel then
				self._mouseover_sll_panel = false
				mouseover_panel:set_visible(false)
				
				sll_panel:child("copy_invite_button_icon"):set_color(text_color_default)
				sll_panel:child("copy_invite_button_text"):set_color(text_color_default)
			end
		end
	end
	
	if self._peers and SystemInfo:platform() == Idstring("WIN32") and MenuCallbackHandler:is_overlay_enabled() then
		for peer_id, object in pairs(self._peers) do
			if alive(object) and object:inside(x, y) then
				used = true
				pointer = "link"
			end
		end
	end

	if self._mutators_tooltip then
		local mutators_text_header = self._contract_panel:child("mutators_text_header")
		local mutators_text = self._contract_panel:child("mutators_text")
		local speed = 6

		if mutators_text_header and mutators_text_header:inside(x, y) or mutators_text and mutators_text:inside(x, y) then
			self._mutators_tooltip:set_world_left(x)
			self._mutators_tooltip:set_world_bottom(y)

			return true, "link"
		end
	end

	return used, pointer
end)
