Hooks:PostHook(CrimeNetSidebarGui,"_setup","sll_menuscenemanager_setupgui",function(self)
	if not ShareLobbyLink.settings.join_button_visible then
		return
	end
	
	local text_color_default = Color(ShareLobbyLink.settings.text_color_default)
	local text_color_mouseover = Color(ShareLobbyLink.settings.text_color_mouseover)
	local bg_color = Color(ShareLobbyLink.settings.bg_color)
	
	local panel = self._fullscreen_panel
	
	local button_w = 276
	local button_h = 48
	local icon_size = 32
	local margin_small = 4
	local margin_medium = 16
	if alive(panel) then 
		self._mouseover_sll_panel = nil --flag to store mouseover state
		
		local in_lobby = false
		if managers.network and managers.network.matchmake then
			if managers.network.matchmake and managers.network.matchmake.lobby_handler then
				if managers.network.matchmake.lobby_handler:id() then
					in_lobby = true
				end
			end
		end
		
		local paste_invite_button_panel = panel:panel({
			name = "paste_invite_button_panel",
			layer = 1,
			y = 96,
			w = button_w,
			h = button_h,
			visible = not in_lobby
		})
		self._sll_paste_invite_button_panel = paste_invite_button_panel
		
		local paste_icon_texture,paste_icon_texture_rect = tweak_data.hud_icons:get_icon_data("sidebar_broker")
		local paste_invite_button_icon = paste_invite_button_panel:bitmap({
			name = "paste_invite_button_icon",
			color = text_color_default,
			x = margin_small,
			y = (paste_invite_button_panel:h() - icon_size) / 2,
			w = icon_size,
			h = icon_size,
			texture = paste_icon_texture,
			texture_rect = paste_icon_texture_rect,
			layer = 2,
		})
		local paste_invite_button_text = paste_invite_button_panel:text({
			name = "paste_invite_button_text",
			text = managers.localization:text("menu_sll_paste_invite_button_text"),
			font_size = tweak_data.menu.pd2_medium_font_size,
			font = tweak_data.menu.pd2_medium_font,
			color = text_color_default,
			x = paste_invite_button_icon:right() + margin_small,
			align = "left",
			vertical = "center",
			layer = 4
		})
		local _x,_y,_w,_h = paste_invite_button_text:text_rect()
		paste_invite_button_panel:set_w(_w + icon_size + margin_small + margin_small + margin_medium)
		paste_invite_button_panel:set_right(panel:right() - 48)
		
		local paste_invite_button_gradient = paste_invite_button_panel:gradient({
			name = "paste_invite_button_gradient",
			gradient_points = {
				0,Color.black,
				1,Color.white
			},
			orientation = "vertical",
			blend_mode = "sub",
			alpha = 0.25,
			layer = 3,
			visible = true
		})
		local paste_invite_button_bar = paste_invite_button_panel:rect({
			name = "paste_invite_button_bar",
			color = Color.white,
			w = 8,
			x = 0,
			alpha = 1,
			layer = 3,
			visible = false
		})
		
		local paste_invite_button_bg = paste_invite_button_panel:rect({
			name = "paste_invite_button_bg",
			color = bg_color,
			alpha = 1,
			layer = 1
		})
	end
	
	
end)


local ids_leftclick = Idstring("0")

local orig_mouse_pressed = Hooks:GetFunction(CrimeNetSidebarGui,"mouse_pressed")
Hooks:OverrideFunction(CrimeNetSidebarGui,"mouse_pressed",function(self,button,x,y,...)
	
	local sll_panel = self._sll_paste_invite_button_panel
	if alive(sll_panel) and sll_panel:visible() then 
		if button == ids_leftclick then 
			local mouseover_panel = sll_panel:child("paste_invite_button_bar")
			if alive(mouseover_panel) then
				if sll_panel:inside(x,y) then 
--					mouseover_panel:stop()
--					mouseover_panel:animate(ShareLobbyLink.animate_clicked)
					
					ShareLobbyLink:join_lobby_from_clipboard()
					
					return true
				end
			end
		end
	end
	
	return orig_mouse_pressed(self,button,x,y,...)
end)

Hooks:PostHook(CrimeNetSidebarGui,"mouse_moved","sll_menuscenemanager_mousemoved",function(self,o,x,y,...)
	local sll_panel = self._sll_paste_invite_button_panel
	if alive(sll_panel) and sll_panel:visible() then 
		local mouseover_panel = sll_panel:child("paste_invite_button_bar")
		if alive(mouseover_panel) then
			local text_color_default = Color(ShareLobbyLink.settings.text_color_default)
			local text_color_mouseover = Color(ShareLobbyLink.settings.text_color_mouseover)
			
			if sll_panel:inside(x,y) then 
				self._mouseover_sll_panel = true
				
				sll_panel:child("paste_invite_button_icon"):set_color(text_color_mouseover)
				sll_panel:child("paste_invite_button_text"):set_color(text_color_mouseover)
				
				return true,"link"
			elseif self._mouseover_sll_panel then
				self._mouseover_sll_panel = false
				
				sll_panel:child("paste_invite_button_icon"):set_color(text_color_default)
				sll_panel:child("paste_invite_button_text"):set_color(text_color_default)
			end
		end
	end
end)
